import java.sql.ResultSet;
import java.sql.SQLException;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

public class ControladorModificar implements TableModelListener {
	VistaModificar vista;
	Modelo modelo;
	
	/**
	 * Carga el controlador
	 * 
	 * @param vista		Vista a controlar
	 * @param modelo	Modelo en el que trabajamos
	 */
	public ControladorModificar(VistaModificar vista, Modelo modelo) {
		this.vista = vista;
		this.modelo = modelo;
		this.cargarFilas();
		vista.dtm.addTableModelListener(this);
	}
	
	/**
	 * Actualiza la tabla
	 */
	public void cargarFilas(){
	        String[] fila = new String[4];
	        vista.dtm.setRowCount(0);
	        ResultSet resultSet = this.modelo.obtenerTransacciones();
			try {
				while (resultSet .next()) {
				    fila[0] = resultSet.getString(1);
				    fila[1] = resultSet.getString(2);
				    fila[2] = resultSet.getString(3);
				    fila[3] = resultSet.getString(4);

				    vista.dtm.addRow(fila);
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
	    }
	
	@Override
	public void tableChanged(TableModelEvent e) {
		if(e.getType() == TableModelEvent.UPDATE){
            System.out.println("actualizada");
            int filaModificada = e.getFirstRow();
            modelo.modificarTransaccion(Integer.parseInt((String)vista.dtm.getValueAt(filaModificada,0)), 
            		(String)vista.dtm.getValueAt(filaModificada,1), 
            		Float.parseFloat((String)vista.dtm.getValueAt(filaModificada,2)), 
            		(String)vista.dtm.getValueAt(filaModificada,3));
        }
		
	}

	
	
}
